import { EthExecutionAPI, JsonRpcResponseWithResult, JsonRpcResult, Web3APIMethod, Web3APIPayload, Web3APIReturnType, Web3APISpec, Web3BaseProvider, Web3ProviderEventCallback, Web3ProviderStatus } from 'web3-types';
export default class IpcProvider<API extends Web3APISpec = EthExecutionAPI> extends Web3BaseProvider<API> {
    private readonly _emitter;
    private readonly _socketPath;
    private readonly _socket;
    private readonly chunkResponseParser;
    private waitOptions;
    private _connectionStatus;
    private readonly _requestQueue;
    constructor(socketPath: string);
    getStatus(): Web3ProviderStatus;
    supportsSubscriptions(): boolean;
    on<T = JsonRpcResult>(type: 'message' | 'connect' | 'disconnect' | string, callback: Web3ProviderEventCallback<T>): void;
    once<T = JsonRpcResult>(type: string, callback: Web3ProviderEventCallback<T>): void;
    removeListener(type: string, callback: Web3ProviderEventCallback): void;
    connect(): void;
    disconnect(): void;
    reset(): void;
    get waitTimeOut(): number;
    set waitTimeOut(timeOut: number);
    get waitMaxNumberOfAttempts(): number;
    set waitMaxNumberOfAttempts(maxNumberOfAttempts: number);
    waitForConnection(): Promise<void>;
    request<Method extends Web3APIMethod<API>, ResultType = Web3APIReturnType<API, Method>>(request: Web3APIPayload<API, Method>): Promise<JsonRpcResponseWithResult<ResultType>>;
    removeAllListeners(type: string): void;
    private _onMessage;
    private _clearQueues;
    private _onConnect;
    private _onDisconnect;
    private _onClose;
    private _addSocketListeners;
    private _removeSocketListeners;
}
//# sourceMappingURL=index.d.ts.map